@use '../../globals.scss';
@use '../../icons.scss';

.agenda-view {
  display: grid;

  grid-template-areas:
    "header header"
    "sidebar content";

  // grid-template-columns: 14em calc(100% - 14em);
  grid-template-columns: 14em calc(100% - 14em);
  grid-template-rows: max-content 1fr;
  overflow: hidden;
  gap: 0.3em;
  z-index: 0; // create new stacking context

  & > .header {
    font-size: 140%;
    padding: 0.1em 0.5em;
    grid-area: header;

    border-bottom: 1px solid var(--border-secondary-color);
    border-radius: var(--border-radius);
    display: grid;
    z-index: 1;

    grid-template-areas:
      "title select_profile"
      "unused show_preview"
      ;

    & > .title {
      margin: 0.3em;
      font-size: inherit;
      grid-area: title;
      align-self: end;
      border-bottom: 1px solid var(--border-secondary-color);
      border-radius: var(--border-radius);
    }
    & > .select_profile {
      margin: 0.3em;
      grid-area: select_profile;
      justify-self: end;
      padding: 0.1em 1em;
      // width: 8em;
    }
    & > .show_preview {
      margin: 0.3em;
      grid-area: show_preview;
      justify-self: end;
      padding: 0.1em 1em;
    }
  }
  & > .sidebar {
    grid-area: sidebar;

    border: 1px solid var(--border-secondary-color);
    border-radius: var(--border-radius);
    padding: 0.3em;
    overflow: hidden;

    display: grid;
    grid-template-areas: "new" "list";
    grid-template-rows: max-content 1fr;


    & > .new {
      height: 2em;
      grid-area: new;
      @include icons.new;
    }

    & > .fragment_list {
      grid-area: list;
      margin-top: 0.3em;
      overflow-y: auto;
      border-top: 1px solid var(--border-secondary-color);

      & > .fragment {
        display: grid;

        border-bottom: 1px solid var(--border-secondary-color);
        grid-template-areas: "selected title status delete";
        grid-template-columns: max-content 1fr max-content max-content;

        transition-duration: 0.3s;

        @include globals.button-like;

        & > .title {
          grid-area: title;
          font-size: 120%;
          padding: 0.3em;
        }
        & > .selected_indicator {
          grid-area: selected;
        }
        &.selected > .selected_indicator {
          width: 0.5em;
          background-color: var(--background-accent-color);
        }

        & > .status_indicator {
          align-self: center;
          grid-area: status;
          width: 1.8em;
          height: 1.8em;
          margin-right: 0.4em;
          transform: translateY(0.05em);
          display: none;
        }
        &[indicator=warning] > .status_indicator {
          @include icons.warning;
          display: unset;
        }
        &[indicator=error] > .status_indicator {
          @include icons.error;
          display: unset;
        }
        &[indicator=loading] > .status_indicator {
          @include icons.loading(0.35em);
          display: unset;
        }

        & > .delete {
          grid-area: delete;
          padding: 0.3em;
          align-self: center;
          width: 1.5em;
          height: 1.5em;
          margin-right: 0.2em;
          transform: translateY(0.05em);

          @include icons.delete;
          border: none;
        }

        &[dragged=true]{
          & > * {
            visibility: hidden;
          }
        }

        &[drop_position=before] {
          padding-top: 2em;
        }
        &[drop_position=after] {
          padding-bottom: 2em;
        }
        
        
      }
    }
  }

  &:not([mode=preview]) > .preview {
    display: none;
  }
  & > .preview {
    z-index: 0;
    position: relative;
    grid-area: content;
    overflow: hidden;

    padding: 0.3em;
    border: 1px solid var(--border-secondary-color);
    border-radius: var(--border-radius);

    display: grid;

    grid-template-areas: 
      "empty save_file get_link new_tab"
      "timetable timetable timetable timetable"
      ;

    column-gap: 0.7em;
    row-gap: 0.7em;

    grid-template-columns: 1fr auto auto auto;
    grid-template-rows: min-content 1fr;
    & > .save_file {
      grid-area: save_file;
      align-self: end;
      color: unset;
      text-decoration: unset;
      padding: 0.2em 1em;
    }
    & > .get_link {
      grid-area: get_link;
      align-self: end;
      padding: 0.2em 1em;
    }
    & > .new_tab {
      grid-area: new_tab;
      align-self: end;
      color: unset;
      text-decoration: unset;
      padding: 0.2em 1em;
    }
    & > .timetable-view {
      grid-area: timetable;
      // align-self: start;
    }

    & > .overlay {
      z-index: 10;
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
    }
  }


  &:not([mode=fragment]) > .fragment_ui {
    display: none;
  }
  & > .fragment_ui {
    position: relative;
    z-index: 0;
    grid-area: content;
    padding: 0.3em;
    border: 1px solid var(--border-secondary-color);
    border-radius: var(--border-radius);

    overflow: hidden;
    & > * {
      box-sizing: border-box;
      height: 100%;
      width: 100%;
    }
  }
}

